



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>手写ButterKnife</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">手写ButterKnife</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-20 08:16:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>开发中使用注解框架可以极大地提高编码效率，注解框架用到的技术可以分为两种，运行时注解跟编译时注解。运行时注解一般配合反射机制使用，编译时注解则是用来生成模板代码。这里我们分别使用这两种方法实现ButterKnife的控件绑定功能。</p>
<h2>1、运行时注解</h2>
<p>运行时注解实现比较简单，但是由于完全依靠反射技术，所以运行效率较低。首先我们需要新建一个注解类，指定其保留时间为运行时，修饰对象为类成员变量，值为控件ID。</p>
<div>
<pre class="prettyprint linenums">@Retention(RetentionPolicy.RUNTIME)<br />
@Target(ElementType.FIELD)<br />
public @interface BindView {<br />
    @IdRes int value();<br />
}
</pre>
</div>
<p>然后我们需要使用反射实现&nbsp;bindView&nbsp;方法。先是使用 class.getDeclaredFields&nbsp;方法获取类中所有的成员变量，如果该成员变量被&nbsp;@BindView&nbsp;注解则根据注解中的控件ID调用 view.findViewById&nbsp;，并将返回值赋给该成员变量。这种方法的一个好处是被&nbsp;@BindView&nbsp;注解的成员变量可以是私有的。</p>
<div>
<pre class="prettyprint linenums">public class ButterKnife {<br />
    public static void bindView(Activity activity) {<br />
        bindView(activity, activity.getWindow().getDecorView());<br />
    }<br />
    public static void bindView(Object object, View view) {<br />
        Class clazz = object.getClass();<br />
        Field[] fields = clazz.getDeclaredFields();<br />
        for (Field f : fields) {<br />
            BindView binder = f.getAnnotation(BindView.class);<br />
            if (binder != null) {<br />
                f.setAccessible(true);<br />
                f.set(object, view.findViewById(binder.value()));<br />
            }<br />
        }<br />
    }<br />
}
</pre>
</div>
<h2>2、编译时注解</h2>
<p>我们知道ButterKnife是基于编译时注解的，依赖注解生成模板代码从而实现控件绑定。使用编译时注解前需要对注解处理器（Annotation Processor）有一个基本了解。</p>
<blockquote><p>Annotation processing is a tool build in javac for scanning and processing annotations&nbsp;<strong>at compile time</strong>. You can register your own annotation processor for certain annotations.</p></blockquote>
<p>在这里我们通过注解处理器自动生成模板代码，并且与项目代码一起编译。</p>
<h3>2.1、创建库项目</h3>
<p>在Android Studio中创建完项目后，我们需要在&nbsp;File -&gt; New -&gt; New Module...&nbsp;创建3个模块。</p>
<table>
<tbody>
<tr>
<td>名称</td>
<td>类别</td>
<td>作用</td>
</tr>
<tr>
<td>test-annotations</td>
<td>Java Liabrary</td>
<td>存放我们自己定义的注解类</td>
</tr>
<tr>
<td>test-api</td>
<td>Android Liabrary</td>
<td>存放在主模块中使用的工具类</td>
</tr>
<tr>
<td>test-compiler</td>
<td>Java Liabrary</td>
<td>存放注解处理器</td>
</tr>
</tbody>
</table>
<p>然后需要在每个模块的build.gradle文件中配置它们之间的依赖关系以及需要用到的类库。</p>
<div>
<pre class="prettyprint linenums">// test-annotations:<br />
dependencies {<br />
    ...<br />
    implementation 'com.android.support:support-annotations:27.1.0@jar'<br />
}

// test-api:<br />
dependencies {<br />
    ...<br />
    compile project(path: ':test-annotations')<br />
}

// test-compiler:<br />
dependencies {<br />
    ...<br />
    compile 'com.google.auto.service:auto-service:1.0-rc2'<br />
    compile project(path: ':test-annotations')<br />
}</pre>
</div>
<h3>2.2、自定义注解</h3>
<p>接下来我们需要在&ldquo;test-annotations&rdquo;模块中创建一个用于控件绑定的注解类，与第一节中类似，不过保留时间更改为了编译时。</p>
<div>
<pre class="prettyprint linenums">@Retention(RetentionPolicy.CLASS)<br />
@Target(ElementType.FIELD)<br />
public @interface BindView {<br />
    @IdRes int value();<br />
}</pre>
</div>
<h3>2.3、创建注解处理器</h3>
<p>处理器的实现在&ldquo;test-compiler&rdquo;模块中，代码比较繁琐，大体上分为两步：收集信息然后生成代码。</p>
<div>
<pre class="prettyprint linenums">@AutoService(Processor.class)<br />
public class TestProcessor extends AbstractProcessor {

    private Filer mFileUtils;<br />
    private Elements mElementUtils;

    @Override<br />
    public synchronized void init(ProcessingEnvironment processingEnvironment) {<br />
        super.init(processingEnvironment);<br />
        mFileUtils = processingEnvironment.getFiler();<br />
        mElementUtils = processingEnvironment.getElementUtils();<br />
    }

    @Override<br />
    public Set&lt;String&gt; getSupportedAnnotationTypes() {<br />
        Set&lt;String&gt; annotationType = new HashSet&lt;&gt;();<br />
        annotationType.add(BindView.class.getCanonicalName());<br />
        return annotationType;<br />
    }

    @Override<br />
    public boolean process(Set&lt;? extends TypeElement&gt; set, RoundEnvironment roundEnvironment) {<br />
        // 处理逻辑...<br />
    }<br />
}
</pre>
</div>
<p>这里使用了谷歌提供的&nbsp;@AutoService&nbsp;对处理器进行注册，然后复写AbstractProcessor类的方法。在&nbsp;getSupportedAnnotationTypes&nbsp;函数中返回处理器支持的注解类型，在&nbsp;init&nbsp;函数中获取我们需要用到的工具类，处理器的主要逻辑则在&nbsp;process&nbsp;函数中。</p>
<div>
<pre class="prettyprint linenums">@Override<br />
public boolean process(Set&lt;? extends TypeElement&gt; set, RoundEnvironment roundEnvironment) {<br />
    Map&lt;String, ClassInfo&gt; classMap = new HashMap&lt;&gt;();<br />
    // 收集信息：<br />
    Set&lt;? extends Element&gt; elements = roundEnvironment.getElementsAnnotatedWith(AnnotationValue.class);<br />
    for (Element element : elements) {<br />
        if (element.getKind() == ElementKind.FIELD) {<br />
            VariableElement variableElement = (VariableElement) element;<br />
            // 获取成员变量所在的类。<br />
            TypeElement typeElement = (TypeElement) variableElement.getEnclosingElement();<br />
            // 获取类的全限定名。<br />
            String qualifeiedName = typeElement.getQualifiedName().toString();<br />
            // 将同一个类的所有成员变量放到一个ClassInfo类中<br />
            ClassInfo classInfo = classMap.get(qualifeiedName);<br />
            if (classInfo == null) {<br />
                PackageElement packageElement = mElementUtils.getPackageOf(typeElement);<br />
                classInfo = new ClassInfo(packageElement, typeElement);<br />
                classMap.put(qualifeiedName, classInfo);<br />
            }<br />
            classInfo.addVariable(variableElement);<br />
        }<br />
    }<br />
    // 生成代码：<br />
    ...<br />
}</pre>
</div>
<p>首先我们通过&nbsp;roundEnvironment.getElementsAnnotatedWith&nbsp;获取到被&nbsp;@BindView&nbsp;注解的所有元素，显然这里的&nbsp;@BindView&nbsp;希望注解在类的成员变量上，所以先对元素的类型进行判断，然后将所有的元素按照所在类的全限定名进行分类（通过ClassInfo类表示）。这里需要了解Element类的含义：</p>
<ul><li>VariableElement：一般代表成员变量。</li>
<li>ExecutableElement：一般代表类中的方法。</li>
<li>TypeElement：一般代表类。</li>
<li>PackageElement：一般代表包。</li></ul>
<div>
<pre class="prettyprint linenums">@Override<br />
public boolean process(Set&lt;? extends TypeElement&gt; set, RoundEnvironment roundEnvironment) {<br />
    // 收集信息：<br />
    ...<br />
    // 生成代码：<br />
    for (String key : classMap.keySet()) {<br />
        ClassInfo classInfo = classMap.get(key);<br />
        try {<br />
            JavaFileObject sourceFile = mFileUtils.createSourceFile(classInfo.getProxyClassFullName());<br />
            Writer writer = sourceFile.openWriter();<br />
            writer.write(classInfo.generateJavaCode());<br />
            writer.flush();<br />
            writer.close();<br />
        } catch (IOException e) {<br />
            e.printStackTrace();<br />
        }<br />
    }<br />
    return true;<br />
}
</pre>
</div>
<p>代码生成阶段比较简单，先使用&nbsp;mFileUtils.createSourceFile&nbsp;函数创建文件对象，文件名通过&nbsp;classInfo.getProxyClassFullName函数获得。然后向该文件对象中写入通过&nbsp;classInfo.generateJavaCode&nbsp;函数获取的源码。接下来看一下ClassInfo类的实现：</p>
<div>
<pre class="prettyprint linenums">public class ClassInfo {<br />
    private String mPackageName;<br />
    private String mProxyClassName;<br />
    private ArrayList&lt;VariableElement&gt; mInjectVariables = new ArrayList&lt;&gt;();<br />
    public static final String PROXY = "ViewInject";

    public ClassInfo(PackageElement packageElement, TypeElement classElement) {<br />
        // 获取包名<br />
        String packageName = packageElement.getQualifiedName().toString();<br />
        this.mPackageName = packageName;<br />
        // 获取全限定名后去除包名，将&lsquo;.&rsquo;替换为&lsquo;$&rsquo;是因为如果类A有个内部<br />
        // 类B，那么B在编译后名字会变为A.B<br />
        int packageLen = packageName.length() + 1;<br />
        String className = classElement.getQualifiedName().toString().substring(packageLen).replace('.', '$');<br />
        // 设置代理类的名字，之后我们需要根据这个名字获取到代理类。<br />
        this.mProxyClassName = className + "$$" + PROXY;<br />
    }<br />
    public String generateJavaCode() {<br />
        StringBuilder builder = new StringBuilder();<br />
        builder.append(String.format("package %s;\n", mPackageName));<br />
        builder.append(String.format("public final class %s {\n", mProxyClassName));<br />
        builder.append(String.format("public %s(%s obj) {\n", mProxyClassName, mClassName));<br />
        for (VariableElement element : mInjectVariables) {<br />
            AnnotationValue binder = element.getAnnotation(AnnotationValue.class);<br />
            String name = element.getSimpleName().toString();<br />
            builder.append(String.format("obj.%s=obj.findViewById(%d);\n", name, binder.value()));<br />
        }<br />
        builder.append("}\n }\n");<br />
        return builder.toString();<br />
    }<br />
    public String getProxyClassFullName() {<br />
        // 返回代理类全限定名<br />
        return mPackageName + "." + mProxyClassName;<br />
    }<br />
    public void addVariable(VariableElement element) {<br />
        mInjectVariables.add(element);<br />
    }<br />
}
</pre>
</div>
<p>它的功能是为我们需要的代理类的生成源码，这里使用了字符串拼接的方式，也有许多第三方库可供使用，如Square公司的JavaPoet。</p>
<h3>2.4、使用处理器</h3>
<p>处理器编写完成后需要在主模块的build.gradle文件中进行配置才能生效，一是引入存放注解的&ldquo;test-annotations&rdquo;模块，二是指定&ldquo;test-compiler&rdquo;模块中的注解处理器。</p>
<div>
<pre class="prettyprint linenums">dependencies {<br />
    ...<br />
    annotationProcessor project(':test-complier')<br />
    compile project(path: ':test-api')<br />
}
</pre>
</div>
<p>接着在MainActivity中用&nbsp;@BindView&nbsp;注解一个控件然后编译项目，编译完成后处理器自动生成的类就可以在主模块的&nbsp;build\generated\source\apt\debug\包名\&nbsp;下找到。</p>
<div>
<pre class="prettyprint linenums">package com.mmmmar.androidannotation;

public final class MainActivity$$ViewInject {<br />
    public MainActivity$$ViewInject(MainActivity obj) {<br />
        obj.mTextView = obj.findViewById(2131165307);<br />
    }<br />
}
</pre>
</div>
<h3>2.5、完成控件绑定</h3>
<p>生成代理类后我们可以在源码中进行手动调用，但是比较优雅的做法是像ButterKnife一样提供一个统一的调用工具，接下来我们在&ldquo;test-api&rdquo;模块中进行实现。</p>
<div>
<pre class="prettyprint linenums">public class ButterKnife {

    public static void bindView(Activity activity) {<br />
        bindView(activity, activity.getWindow().getDecorView());<br />
    }<br />
    public static void bindView(Object object, View view) {<br />
        Class clazz = object.getClass();<br />
        String clazzName = clazz.getCanonicalName() + "$$ViewInject";<br />
        try {<br />
            Class proxy = clazz.getClassLoader().loadClass(clazzName);<br />
            Constructor constructor = proxy.getConstructor(clazz);<br />
            constructor.newInstance(object);<br />
        } catch (ClassNotFoundException e) {<br />
            e.printStackTrace();<br />
        } catch (NoSuchMethodException e) {<br />
            e.printStackTrace();<br />
        } catch (IllegalAccessException e) {<br />
            e.printStackTrace();<br />
        } catch (InstantiationException e) {<br />
            e.printStackTrace();<br />
        } catch (InvocationTargetException e) {<br />
            e.printStackTrace();<br />
        }<br />
    }<br />
}</pre>
</div>
<p>因为处理器生成的代理类的逻辑都在构造函数中，所以我们只需要通过类加载器根据类名获取到代理类的Class对象，然后调用其构造函数即可完成功能。虽然这里也用到了反射，但只是用来调用一次代理类的构造函数，所以不会对性能照成影响。　　</p>
<p>参考：&nbsp;<a href="https://blog.csdn.net/lmj623565791/article/details/51931859" rel="external nofollow noreferrer">Android 如何编写基于编译时注解的项目</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwrkek9.html">C&plus;&plus;中的private&sol;protected&sol;public</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q70x3e8.html">ES6 对象解构</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxjyd09.html">memset中的sizeof</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq402738.html">TSPL学习笔记&lpar;4&rpar;&colon;数组相关练习</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z5do09.html">Java-马士兵设计模式学习笔记-建造者模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1vy3x9.html">在同一上机器上建立两个SVN服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdnd7z9.html">linux之grep用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yxg4g8.html">Mysql自增主键ID重新排序方法详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkkkov8.html">hdu2089不要62（数位dp）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jmr538.html">JAVA中的访问修饰符和包</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj42528.html">ADO&period;NET生成的数据库连接字符串解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkm4o08.html">sqlplus 登录数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojenv5q.html">PHP数字金额转换大写金额</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy4lvmq.html">十三、u-boot 调试-- NOR FLASH 支持</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rkdmn9.html">2018面向对象程序设计（Java）第16周学习指导及要求</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlld1lkq.html">python小工具myqr生成动态二维码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwz3o48.html">&lpar;3&rpar;The critical role librarians play in the opioid crisis</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn5prmq.html">【转载并整理】mysql 创建用户，数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/8komk45q.html">eclipse中改变默认的workspace的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p6wo3q.html">javascript iframe相关操作</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8mevyg6q.html">mysql常用基础操作语法（九）~~外连接查询【命令行模式】</a>
			</li>
						<li><a href="https://www.batexi.com/a/93ylg408.html">JAVA之编码----&amp;gt&semi;CSV在文本下是正常的，用EXCEL打开是乱码的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jnv338.html">Linux显示查看您拥有的仓库</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp3lyxq.html">linq查询集合并分页展示数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjep0r8.html">freemarker写select组件（二十二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjempz8.html">【BZOJ2132】圈地计划（最小割）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kn6359.html">【BZOJ3669】【Noi2014】魔法森林（Link-Cut Tree）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkrm1e8.html">【Luogu3808】多项式乘法FFT（FFT）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1oy01q.html">NOIP提高组 2013货车运输</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yl4nn8.html">&lbrack;HNOI2011&rsqb;XOR和路径</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
